package org.modeshape.example.auth;

import java.util.Map;

import javax.jcr.Credentials;

import org.modeshape.graph.ExecutionContext;
import org.modeshape.graph.SecurityContext;

import org.modeshape.jcr.security.AuthenticationProvider;

/**
 * Instantiated by Modeshape from config:
 * 
   
            <mode:authenticationProviders>
                <mode:authenticationProvider jcr:name="customModeshapeAuthenticationProvider"
                                             mode:classname="org.modeshape.example.auth.CustomAuthenticationProviderImpl" />
            </mode:authenticationProviders>

 */
public class CustomAuthenticationProviderImpl implements AuthenticationProvider {

	
	/**
	 * Instantiate in constructor 
	 */
	private final SecurityContext securityContext;
	
	public CustomAuthenticationProviderImpl() {
		System.out.println("Instantiating SecurityContext  in constructor of " + this.getClass().getName());
		
		securityContext = new CustomSecurityContextImpl();
	}


	/* (non-Javadoc)
	 * @see org.modeshape.jcr.security.AuthenticationProvider#authenticate(javax.jcr.Credentials, java.lang.String, java.lang.String, org.modeshape.graph.ExecutionContext, java.util.Map)
	 */
	public ExecutionContext authenticate(Credentials credentials, String repositoryName, String workspaceName, ExecutionContext repositoryContext, Map<String, Object> sessionAttributes) {
		System.out.println("Getting ExecutionContext() 'with' securityContext");
		
		return repositoryContext.with(securityContext);
	}

}
